Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/FULL-RUN-MASTER-SPARK-POS-COUNT.sh
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/FULL-RUN-MASTER-SPARK-POS-COUNT.sh	(revision 31258)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/scripts/FULL-RUN-MASTER-SPARK-POS-COUNT.sh	(revision 31258)
@@ -0,0 +1,20 @@
+#!/bin/bash
+
+json_filelist=${1:-full-listing-step100000.txt}
+shift
+
+input_dir="hdfs://$SPARK_MASTER_HOST:9000/tmp/dbbridge/full-ef-json-files"
+#input_dir="hdfs://master:9000/user/htrc/full-ef-json-files"
+#input_dir="hdfs://10.10.0.52:9000/user/htrc/full-ef-json-files"
+
+#output_dir=hdfs://master:9000/user/htrc/full-solr-json-files
+solr_url="http://gc0:8983/solr/htrc-full-ef/update"
+
+# 
+
+master_opt="--executor-memory 10g --conf spark.executor.extraJavaOptions=-XX:+HeapDumpOnOutOfMemoryError --master spark://$SPARK_MASTER_HOST:7077"
+
+classmain="org.hathitrust.extractedfeatures.ProcessForPOSCount"
+
+. scripts/_RUN.sh
+
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/PerVolumePOSStreamFlatmap.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/PerVolumePOSStreamFlatmap.java	(revision 31258)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/PerVolumePOSStreamFlatmap.java	(revision 31258)
@@ -0,0 +1,116 @@
+package org.hathitrust.extractedfeatures;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Iterator;
+
+import org.apache.spark.api.java.function.FlatMapFunction;
+import org.apache.spark.util.DoubleAccumulator;
+import org.json.JSONArray;
+import org.json.JSONObject;
+
+class PerVolumePOSStreamFlatmap implements FlatMapFunction<String, String>
+{
+	private static final long serialVersionUID = 1L;
+	
+	protected String _input_dir;
+	protected int    _verbosity;
+	
+	protected DoubleAccumulator _progress_accum;
+	protected double            _progress_step;
+	
+	boolean _strict_file_io;
+	
+	public PerVolumePOSStreamFlatmap(String input_dir, int verbosity, 
+					 		  DoubleAccumulator progress_accum, double progress_step,
+					 		  boolean strict_file_io)
+	{
+		_input_dir  = input_dir;
+		_verbosity  = verbosity;
+		
+		_progress_accum = progress_accum;
+		_progress_step  = progress_step;
+		
+		_strict_file_io = strict_file_io;
+	}
+	
+	public Iterator<String> call(String json_file_in) throws IOException
+	{ 
+	     
+		String full_json_file_in = _input_dir + "/" + json_file_in;
+		JSONObject extracted_feature_record = JSONClusterFileIO.readJSONFile(full_json_file_in);
+		
+		ArrayList<String> all_word_list = new ArrayList<String>();
+		
+		if (extracted_feature_record != null) {
+			String volume_id = extracted_feature_record.getString("id");
+
+			JSONObject ef_features = extracted_feature_record.getJSONObject("features");
+
+			int ef_page_count = ef_features.getInt("pageCount");
+
+			if (_verbosity >= 1) {
+				System.out.println("Processing: " + json_file_in);
+				System.out.println("  pageCount = " + ef_page_count);
+			}
+
+			JSONArray ef_pages = ef_features.getJSONArray("pages");
+			int ef_num_pages = ef_pages.length();
+			if (ef_num_pages != ef_page_count) {
+				System.err.println("Warning: number of page elements in JSON (" + ef_num_pages + ")"
+						+" does not match 'pageCount' metadata (" + ef_page_count + ")"); 
+			}
+	
+			if (_verbosity >= 2) {
+				System.out.print("  Pages: ");
+			}
+
+			for (int i = 0; i < ef_page_count; i++) {
+				String formatted_i = String.format("page-%06d", i);
+				String page_id = volume_id + "." + formatted_i;
+
+				if (_verbosity >= 2) {
+					if (i>0) {
+						System.out.print(", ");
+					}
+					System.out.print(page_id);
+				}
+
+				if (i==(ef_page_count-1)) {
+					if (_verbosity >= 2) {
+						System.out.println();
+					}
+				}
+
+				JSONObject ef_page = ef_pages.getJSONObject(i);
+
+				if (ef_page != null) {
+					
+					ArrayList<String> page_word_list = SolrDocJSON.generateTokenPosCountPOSLabels(volume_id, page_id, ef_page);					
+					all_word_list.addAll(page_word_list);
+				}
+				else {
+					System.err.println("Skipping: " + page_id);
+				}
+			}
+		}
+		else {
+			// File did not exist, or could not be parsed
+			String mess = "Failed to read in bzipped JSON file '" + full_json_file_in + "'";
+			if (_strict_file_io) {
+				throw new IOException(mess);
+			}
+			else {
+				System.err.println("Warning: " + mess);
+				System.out.println("Warning: " + mess);
+			}
+		}
+
+		_progress_accum.add(_progress_step);
+		
+		return all_word_list.iterator();
+	}
+	
+	
+}
+
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForPOSCount.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForPOSCount.java	(revision 31258)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForPOSCount.java	(revision 31258)
@@ -0,0 +1,195 @@
+package org.hathitrust.extractedfeatures;
+
+import java.io.BufferedInputStream;
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
+import java.io.IOException;
+import java.io.Serializable;
+import org.apache.commons.cli.*;
+
+import org.apache.spark.api.java.*;
+import org.apache.spark.api.java.function.Function2;
+import org.apache.spark.api.java.function.PairFunction;
+import org.apache.spark.util.DoubleAccumulator;
+import scala.Tuple2;
+
+import org.apache.spark.SparkConf;
+
+public class ProcessForPOSCount implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+
+	// Following details on number of partitions to use given in 
+	//  "Parallelized collections" section of:
+	//   https://spark.apache.org/docs/2.0.1/programming-guide.html
+	//
+	// For a more detailed discussion see:
+	//   http://blog.cloudera.com/blog/2015/03/how-to-tune-your-apache-spark-jobs-part-2/
+	
+	protected static final int DEFAULT_NUM_CORES = 6;
+	protected static final int DEFAULT_NUM_PARTITIONS = 3*DEFAULT_NUM_CORES; 
+	
+	protected String _input_dir;
+	protected String _json_list_filename;
+	
+	protected int    _verbosity;
+
+	public ProcessForPOSCount(String input_dir, String json_list_filename, int verbosity)
+	{
+		_input_dir = input_dir;
+		_json_list_filename = (json_list_filename != null) ? json_list_filename : input_dir;
+
+		_verbosity  = verbosity;
+	}
+
+	protected String generateSparkAppName(String exec_mode)
+	{
+		String spark_app_name = "[" + exec_mode + "] Extracted Features: Process for POS";
+		spark_app_name += " [" + _json_list_filename + "]";
+	
+		return spark_app_name;
+	}
+		
+	public void execPOSCount()
+	{	
+		String spark_app_name = generateSparkAppName("Per Page");		
+		
+		SparkConf conf = new SparkConf().setAppName(spark_app_name);
+		JavaSparkContext jsc = new JavaSparkContext(conf);
+
+		String filename_root = _json_list_filename.replaceAll(".*/","").replaceAll("\\..*$","");
+		String output_directory = "pos-" + filename_root + "-out";
+		if (ClusterFileIO.exists(output_directory))
+		{
+			System.err.println("Error: " + output_directory + " already exists.  Spark unable to write output data");
+			jsc.close();
+			System.exit(1);
+		}
+		
+		int num_partitions = Integer.getInteger("wcsa-ef-ingest.num-partitions", DEFAULT_NUM_PARTITIONS);
+		JavaRDD<String> json_list_data = jsc.textFile(_json_list_filename,num_partitions).cache();
+		json_list_data.setName("JSON-file-list");
+		
+		long num_volumes = json_list_data.count();
+		double per_vol = 100.0/(double)num_volumes;
+
+		DoubleAccumulator per_vol_progress_accum = jsc.sc().doubleAccumulator("Per Volume Progress Percent");
+		
+		boolean strict_file_io = Boolean.getBoolean("wcsa-ef-ingest.strict-file-io");
+		//boolean icu_tokenize = Boolean.getBoolean("wcsa-ef-ingest.icu-tokenize");
+		
+		PerVolumePOSStreamFlatmap paged_solr_wordfreq_flatmap 
+			= new PerVolumePOSStreamFlatmap(_input_dir,_verbosity, 
+								     per_vol_progress_accum,per_vol,
+								     strict_file_io);
+		JavaRDD<String> pos_list = json_list_data.flatMap(paged_solr_wordfreq_flatmap); 
+		pos_list.setName("pos-stream");
+		
+		/*
+		JavaPairRDD<String, Integer> pos_pairs = pos_list.mapToPair(new PairFunction<String, String, Integer>() {
+			public Tuple2<String, Integer> call(String s) { return new Tuple2<String, Integer>(s, 1); }
+		});
+		pos_pairs.setName("single-pos-count");
+		
+		JavaPairRDD<String, Integer> pos_counts = pos_pairs.reduceByKey(new Function2<Integer, Integer, Integer>() {
+			public Integer call(Integer a, Integer b) { return a + b; }
+		});
+		pos_counts.setName("pos-frequency");
+		*/
+		
+		JavaPairRDD<String, Integer> pos_pairs = pos_list.mapToPair(s -> new Tuple2<String, Integer>(s, 1));
+		pos_pairs.setName("single-pos-count");
+		
+		JavaPairRDD<String, Integer> pos_counts = pos_pairs.reduceByKey((a, b) -> a + b);
+		pos_counts.setName("pos-frequency");
+		
+		JavaPairRDD<Integer, String> pos_counts_swapped_pair
+			= pos_counts.mapToPair(item -> item.swap());
+		pos_counts_swapped_pair.setName("frequency-pos-swap");
+		
+		JavaPairRDD<Integer, String> pos_counts_swapped_pair_sorted 
+			= pos_counts_swapped_pair.sortByKey(true, num_partitions);
+		pos_counts_swapped_pair_sorted.setName("descending-sorted-frequency-pos");
+		
+		JavaPairRDD<String, Integer> pos_count_sorted 
+			= pos_counts_swapped_pair_sorted.mapToPair(item -> item.swap());
+		pos_count_sorted.setName("descending-pos-frequency");
+		
+		
+		pos_count_sorted.saveAsTextFile(output_directory);
+		jsc.close();
+	}
+
+	
+	public static void print_usage(HelpFormatter formatter, Options options)
+	{
+		formatter.printHelp("RUN.bash [options] input-dir json-filelist.txt", options);
+	}
+	
+	public static void main(String[] args) {
+		Options options = new Options();
+
+		Option verbosity_opt = new Option("v", "verbosity", true, 
+				"Set to control the level of debugging output [0=none, 1=some, 2=lots]");
+		verbosity_opt.setRequired(false);
+		options.addOption(verbosity_opt);
+		
+		Option properties_opt = new Option("p", "properties", true, 
+				"Read in the specified Java properties file");
+		properties_opt.setRequired(false);
+		options.addOption(properties_opt);
+		
+		// Need to work with CLI v1.2 as this is the JAR that is bundled with Hadoop/Spark 
+		CommandLineParser parser = new GnuParser(); 
+		//CommandLineParser parser = new DefaultParser(); // if working with CLI v1.3 and above
+		
+		HelpFormatter formatter = new HelpFormatter();
+		CommandLine cmd = null;
+
+		try {
+			cmd = parser.parse(options, args);
+		}
+		catch (ParseException e) {
+			System.err.println(e.getMessage());
+			print_usage(formatter,options);
+			System.exit(1);
+		}
+
+		String verbosity_str = cmd.getOptionValue("verbosity","1");
+		int verbosity = Integer.parseInt(verbosity_str);
+
+		String property_filename = cmd.getOptionValue("properties",null);
+		
+		String[] filtered_args = cmd.getArgs();
+
+		if (filtered_args.length != 2) {
+			print_usage(formatter,options);
+			System.exit(1);
+		}
+	
+		if (property_filename != null) {
+			try {
+				FileInputStream fis = new FileInputStream(property_filename);
+				BufferedInputStream bis = new BufferedInputStream(fis);
+				
+				System.getProperties().load(bis);
+			} 
+			catch (FileNotFoundException e) {
+				e.printStackTrace();
+				System.err.println("File not found: '" + property_filename + "'. Skipping property file read");
+			}
+			catch (IOException e) {
+				System.err.println("IO Exception for: '" + property_filename + "'. Malformed syntax? Skipping property file read");
+			}
+		}
+				
+		String input_dir  = filtered_args[0];
+		String json_list_filename = filtered_args[1];
+		
+		ProcessForPOSCount prep_for_pos 
+			= new ProcessForPOSCount(input_dir,json_list_filename,verbosity);
+		
+		prep_for_pos.execPOSCount();
+	
+	}
+}
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/SolrDocJSON.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/SolrDocJSON.java	(revision 31257)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/SolrDocJSON.java	(revision 31258)
@@ -31,10 +31,10 @@
 		if (ef_token_pos_count != null) {
 
-			Iterator<String> token_iter = ef_token_pos_count.keys();
-			while (token_iter.hasNext()) {
-				String token = token_iter.next();
+			Iterator<String> word_token_iter = ef_token_pos_count.keys();
+			while (word_token_iter.hasNext()) {
+				String word_token = word_token_iter.next();
 				
 				if (icu_tokenize == true) {
-					Reader reader = new StringReader(token);
+					Reader reader = new StringReader(word_token);
 					
 					ICUTokenizer icu_tokenizer = new ICUTokenizer();
@@ -68,5 +68,5 @@
 				}
 				else {
-					words.add(token);
+					words.add(word_token);
 				}
 			}				
@@ -84,4 +84,32 @@
 		return words;
 	}
+	
+	protected static ArrayList<String> getTokenPosCountPOSLabels(JSONObject ef_token_pos_count, String page_id)
+	{
+		ArrayList<String> pos_labels = new ArrayList<String>();
+
+		if (ef_token_pos_count != null) {
+
+			Iterator<String> word_token_iter = ef_token_pos_count.keys();
+			while (word_token_iter.hasNext()) {
+				String word_token = word_token_iter.next();
+				
+				JSONObject word_pos_labels = ef_token_pos_count.getJSONObject(word_token);
+				
+				Iterator<String> pos_token_iter = word_pos_labels.keys();
+				while (pos_token_iter.hasNext()) {
+					String pos_token = pos_token_iter.next();
+						
+					pos_labels.add(pos_token);
+				}
+			}				
+		}
+		else {
+			System.err.println("Warning: empty tokenPosCount field for '" + page_id + "'");
+		}
+
+		return pos_labels;
+	}
+
 	
 	
@@ -221,6 +249,6 @@
 	}
 
-	protected static ArrayList<String> generateTokenPosCountText(String volume_id, String page_id, JSONObject ef_page,
-																 boolean icu_tokenize) 
+	public static ArrayList<String> generateTokenPosCountText(String volume_id, String page_id, JSONObject ef_page,
+															  boolean icu_tokenize) 
 	{
 		ArrayList<String> word_list = null;
@@ -241,4 +269,26 @@
 		}
 		
+		return word_list;
+	}
+	
+	public static ArrayList<String> generateTokenPosCountPOSLabels(String volume_id, String page_id, JSONObject ef_page) 
+	{
+		ArrayList<String> word_list = null;
+
+		if (ef_page != null) {
+			JSONObject ef_body = ef_page.getJSONObject("body");
+			if (ef_body != null) {
+				JSONObject ef_token_pos_count = ef_body.getJSONObject("tokenPosCount");
+				word_list = getTokenPosCountPOSLabels(ef_token_pos_count,page_id);
+			}
+			else {
+				System.err.println("Warning: empty body field for '" + page_id + "'");
+			}
+
+		}
+		else {
+			System.err.println("Warning: null page for '" + page_id + "'");
+		}
+
 		return word_list;
 	}