Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/PerVolumeLangStreamFlatmap.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/PerVolumeLangStreamFlatmap.java	(revision 31260)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/PerVolumeLangStreamFlatmap.java	(revision 31260)
@@ -0,0 +1,116 @@
+package org.hathitrust.extractedfeatures;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Iterator;
+
+import org.apache.spark.api.java.function.FlatMapFunction;
+import org.apache.spark.util.DoubleAccumulator;
+import org.json.JSONArray;
+import org.json.JSONObject;
+
+class PerVolumeLangStreamFlatmap implements FlatMapFunction<String, String>
+{
+	private static final long serialVersionUID = 1L;
+	
+	protected String _input_dir;
+	protected int    _verbosity;
+	
+	protected DoubleAccumulator _progress_accum;
+	protected double            _progress_step;
+	
+	boolean _strict_file_io;
+	
+	public PerVolumeLangStreamFlatmap(String input_dir, int verbosity, 
+					 		  DoubleAccumulator progress_accum, double progress_step,
+					 		  boolean strict_file_io)
+	{
+		_input_dir  = input_dir;
+		_verbosity  = verbosity;
+		
+		_progress_accum = progress_accum;
+		_progress_step  = progress_step;
+		
+		_strict_file_io = strict_file_io;
+	}
+	
+	public Iterator<String> call(String json_file_in) throws IOException
+	{ 
+	     
+		String full_json_file_in = _input_dir + "/" + json_file_in;
+		JSONObject extracted_feature_record = JSONClusterFileIO.readJSONFile(full_json_file_in);
+		
+		ArrayList<String> all_word_list = new ArrayList<String>();
+		
+		if (extracted_feature_record != null) {
+			String volume_id = extracted_feature_record.getString("id");
+
+			JSONObject ef_features = extracted_feature_record.getJSONObject("features");
+
+			int ef_page_count = ef_features.getInt("pageCount");
+
+			if (_verbosity >= 1) {
+				System.out.println("Processing: " + json_file_in);
+				System.out.println("  pageCount = " + ef_page_count);
+			}
+
+			JSONArray ef_pages = ef_features.getJSONArray("pages");
+			int ef_num_pages = ef_pages.length();
+			if (ef_num_pages != ef_page_count) {
+				System.err.println("Warning: number of page elements in JSON (" + ef_num_pages + ")"
+						+" does not match 'pageCount' metadata (" + ef_page_count + ")"); 
+			}
+	
+			if (_verbosity >= 2) {
+				System.out.print("  Pages: ");
+			}
+
+			for (int i = 0; i < ef_page_count; i++) {
+				String formatted_i = String.format("page-%06d", i);
+				String page_id = volume_id + "." + formatted_i;
+
+				if (_verbosity >= 2) {
+					if (i>0) {
+						System.out.print(", ");
+					}
+					System.out.print(page_id);
+				}
+
+				if (i==(ef_page_count-1)) {
+					if (_verbosity >= 2) {
+						System.out.println();
+					}
+				}
+
+				JSONObject ef_page = ef_pages.getJSONObject(i);
+
+				if (ef_page != null) {
+					
+					ArrayList<String> page_word_list = SolrDocJSON.generateTokenPosCountLangLabels(volume_id, page_id, ef_page);					
+					all_word_list.addAll(page_word_list);
+				}
+				else {
+					System.err.println("Skipping: " + page_id);
+				}
+			}
+		}
+		else {
+			// File did not exist, or could not be parsed
+			String mess = "Failed to read in bzipped JSON file '" + full_json_file_in + "'";
+			if (_strict_file_io) {
+				throw new IOException(mess);
+			}
+			else {
+				System.err.println("Warning: " + mess);
+				System.out.println("Warning: " + mess);
+			}
+		}
+
+		_progress_accum.add(_progress_step);
+		
+		return all_word_list.iterator();
+	}
+	
+	
+}
+
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForLangCount.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForLangCount.java	(revision 31260)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForLangCount.java	(revision 31260)
@@ -0,0 +1,183 @@
+package org.hathitrust.extractedfeatures;
+
+import java.io.BufferedInputStream;
+import java.io.FileInputStream;
+import java.io.FileNotFoundException;
+import java.io.IOException;
+import java.io.Serializable;
+import org.apache.commons.cli.*;
+
+import org.apache.spark.api.java.*;
+import org.apache.spark.api.java.function.Function2;
+import org.apache.spark.api.java.function.PairFunction;
+import org.apache.spark.util.DoubleAccumulator;
+import scala.Tuple2;
+
+import org.apache.spark.SparkConf;
+
+public class ProcessForLangCount implements Serializable
+{
+	private static final long serialVersionUID = 1L;
+
+	// Following details on number of partitions to use given in 
+	//  "Parallelized collections" section of:
+	//   https://spark.apache.org/docs/2.0.1/programming-guide.html
+	//
+	// For a more detailed discussion see:
+	//   http://blog.cloudera.com/blog/2015/03/how-to-tune-your-apache-spark-jobs-part-2/
+	
+	protected static final int DEFAULT_NUM_CORES = 6;
+	protected static final int DEFAULT_NUM_PARTITIONS = 3*DEFAULT_NUM_CORES; 
+	
+	protected String _input_dir;
+	protected String _json_list_filename;
+	
+	protected int    _verbosity;
+
+	public ProcessForLangCount(String input_dir, String json_list_filename, int verbosity)
+	{
+		_input_dir = input_dir;
+		_json_list_filename = (json_list_filename != null) ? json_list_filename : input_dir;
+
+		_verbosity  = verbosity;
+	}
+
+	protected String generateSparkAppName(String exec_mode)
+	{
+		String spark_app_name = "[" + exec_mode + "] Extracted Features: Process for Language Labels";
+		spark_app_name += " [" + _json_list_filename + "]";
+	
+		return spark_app_name;
+	}
+		
+	public void execPOSCount()
+	{	
+		String spark_app_name = generateSparkAppName("Per Page");		
+		
+		SparkConf conf = new SparkConf().setAppName(spark_app_name);
+		JavaSparkContext jsc = new JavaSparkContext(conf);
+
+		String filename_root = _json_list_filename.replaceAll(".*/","").replaceAll("\\..*$","");
+		String output_directory = "lang-" + filename_root + "-out";
+		if (ClusterFileIO.exists(output_directory))
+		{
+			System.err.println("Error: " + output_directory + " already exists.  Spark unable to write output data");
+			jsc.close();
+			System.exit(1);
+		}
+		
+		int num_partitions = Integer.getInteger("wcsa-ef-ingest.num-partitions", DEFAULT_NUM_PARTITIONS);
+		JavaRDD<String> json_list_data = jsc.textFile(_json_list_filename,num_partitions).cache();
+		json_list_data.setName("JSON-file-list");
+		
+		long num_volumes = json_list_data.count();
+		double per_vol = 100.0/(double)num_volumes;
+
+		DoubleAccumulator per_vol_progress_accum = jsc.sc().doubleAccumulator("Per Volume Progress Percent");
+		
+		boolean strict_file_io = Boolean.getBoolean("wcsa-ef-ingest.strict-file-io");
+		
+		PerVolumeLangStreamFlatmap paged_solr_langfreq_flatmap 
+			= new PerVolumeLangStreamFlatmap(_input_dir,_verbosity, 
+								     per_vol_progress_accum,per_vol,
+								     strict_file_io);
+		JavaRDD<String> lang_list = json_list_data.flatMap(paged_solr_langfreq_flatmap); 
+		lang_list.setName("lang-stream");
+	
+		
+		JavaPairRDD<String, Integer> lang_pairs = lang_list.mapToPair(s -> new Tuple2<String, Integer>(s, 1));
+		lang_pairs.setName("single-lang-count");
+		
+		JavaPairRDD<String, Integer> lang_counts = lang_pairs.reduceByKey((a, b) -> a + b);
+		lang_counts.setName("lang-frequency");
+		
+		JavaPairRDD<Integer, String> lang_counts_swapped_pair
+			= lang_counts.mapToPair(item -> item.swap());
+		lang_counts_swapped_pair.setName("frequency-lang-swap");
+		
+		JavaPairRDD<Integer, String> lang_counts_swapped_pair_sorted 
+			= lang_counts_swapped_pair.sortByKey(false, num_partitions);
+		lang_counts_swapped_pair_sorted.setName("descending-sorted-frequency-pos");
+		
+		JavaPairRDD<String, Integer> lang_count_sorted 
+			= lang_counts_swapped_pair_sorted.mapToPair(item -> item.swap());
+		lang_count_sorted.setName("descending-lang-frequency");
+		
+		
+		lang_count_sorted.saveAsTextFile(output_directory);
+		jsc.close();
+	}
+
+	
+	public static void print_usage(HelpFormatter formatter, Options options)
+	{
+		formatter.printHelp("RUN.bash [options] input-dir json-filelist.txt", options);
+	}
+	
+	public static void main(String[] args) {
+		Options options = new Options();
+
+		Option verbosity_opt = new Option("v", "verbosity", true, 
+				"Set to control the level of debugging output [0=none, 1=some, 2=lots]");
+		verbosity_opt.setRequired(false);
+		options.addOption(verbosity_opt);
+		
+		Option properties_opt = new Option("p", "properties", true, 
+				"Read in the specified Java properties file");
+		properties_opt.setRequired(false);
+		options.addOption(properties_opt);
+		
+		// Need to work with CLI v1.2 as this is the JAR that is bundled with Hadoop/Spark 
+		CommandLineParser parser = new GnuParser(); 
+		//CommandLineParser parser = new DefaultParser(); // if working with CLI v1.3 and above
+		
+		HelpFormatter formatter = new HelpFormatter();
+		CommandLine cmd = null;
+
+		try {
+			cmd = parser.parse(options, args);
+		}
+		catch (ParseException e) {
+			System.err.println(e.getMessage());
+			print_usage(formatter,options);
+			System.exit(1);
+		}
+
+		String verbosity_str = cmd.getOptionValue("verbosity","1");
+		int verbosity = Integer.parseInt(verbosity_str);
+
+		String property_filename = cmd.getOptionValue("properties",null);
+		
+		String[] filtered_args = cmd.getArgs();
+
+		if (filtered_args.length != 2) {
+			print_usage(formatter,options);
+			System.exit(1);
+		}
+	
+		if (property_filename != null) {
+			try {
+				FileInputStream fis = new FileInputStream(property_filename);
+				BufferedInputStream bis = new BufferedInputStream(fis);
+				
+				System.getProperties().load(bis);
+			} 
+			catch (FileNotFoundException e) {
+				e.printStackTrace();
+				System.err.println("File not found: '" + property_filename + "'. Skipping property file read");
+			}
+			catch (IOException e) {
+				System.err.println("IO Exception for: '" + property_filename + "'. Malformed syntax? Skipping property file read");
+			}
+		}
+				
+		String input_dir  = filtered_args[0];
+		String json_list_filename = filtered_args[1];
+		
+		ProcessForPOSCount prep_for_pos 
+			= new ProcessForPOSCount(input_dir,json_list_filename,verbosity);
+		
+		prep_for_pos.execPOSCount();
+	
+	}
+}
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForPOSCount.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForPOSCount.java	(revision 31259)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/ProcessForPOSCount.java	(revision 31260)
@@ -45,5 +45,5 @@
 	protected String generateSparkAppName(String exec_mode)
 	{
-		String spark_app_name = "[" + exec_mode + "] Extracted Features: Process for POS";
+		String spark_app_name = "[" + exec_mode + "] Extracted Features: Process for POS Count";
 		spark_app_name += " [" + _json_list_filename + "]";
 	
@@ -79,9 +79,9 @@
 		//boolean icu_tokenize = Boolean.getBoolean("wcsa-ef-ingest.icu-tokenize");
 		
-		PerVolumePOSStreamFlatmap paged_solr_wordfreq_flatmap 
+		PerVolumePOSStreamFlatmap paged_solr_posfreq_flatmap 
 			= new PerVolumePOSStreamFlatmap(_input_dir,_verbosity, 
 								     per_vol_progress_accum,per_vol,
 								     strict_file_io);
-		JavaRDD<String> pos_list = json_list_data.flatMap(paged_solr_wordfreq_flatmap); 
+		JavaRDD<String> pos_list = json_list_data.flatMap(paged_solr_posfreq_flatmap); 
 		pos_list.setName("pos-stream");
 		
Index: other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/SolrDocJSON.java
===================================================================
--- other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/SolrDocJSON.java	(revision 31259)
+++ other-projects/hathitrust/wcsa/extracted-features-solr/trunk/solr-ingest/src/main/java/org/hathitrust/extractedfeatures/SolrDocJSON.java	(revision 31260)
@@ -13,4 +13,5 @@
 import java.util.Iterator;
 import org.apache.commons.compress.compressors.CompressorException;
+import org.json.JSONArray;
 import org.json.JSONObject;
 import org.apache.lucene.analysis.TokenStream;
@@ -294,4 +295,36 @@
 	}
 	
+	public static ArrayList<String> generateTokenPosCountLangLabels(String volume_id, String page_id, JSONObject ef_page) 
+	{
+		ArrayList<String> lang_list = new ArrayList<String>();;
+
+		if (ef_page != null) {
+			JSONArray ef_languages = ef_page.getJSONArray("languages");
+			if (ef_languages != null) {
+				
+				int lang_len = ef_languages.length();
+				for (int i=0; i<lang_len; i++) {
+					JSONObject lang_rec = ef_languages.getJSONObject(i);
+
+					Iterator<String> lang_key_iter = lang_rec.keys();
+					while (lang_key_iter.hasNext()) {
+						String lang_label = lang_key_iter.next();
+
+						lang_list.add(lang_label);
+					}
+				}
+			}
+			else {
+				System.err.println("Warning: empty languages field for '" + page_id + "'");
+			}
+
+		}
+		else {
+			System.err.println("Warning: null page for '" + page_id + "'");
+		}
+
+		return lang_list;
+	}
+	
 	public static void saveSolrDoc(JSONObject solr_add_doc_json, String output_file_json_bz2)
 	{