Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-start-configservers.sh
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-start-configservers.sh	(revision 31302)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-start-configservers.sh	(revision 31303)
@@ -2,5 +2,5 @@
 
 for h in $MONGODB_CONFIG_HOSTS ; do
-  echo "* Starting MongoDB Config Server on $h:27019"
-  ssh $h "mongod --configsvr --dbpath \"$MONGODB_DBDIR/config-metadata\" --port 27019 > mongodb-output-$h-config.log &"
+  echo "* Starting MongoDB Config Server on $h:$MONGODB_CONFIG_PORT"
+  ssh $h "mongod --configsvr --dbpath \"$MONGODB_DBDIR/config-metadata\" --port $MONGODB_CONFIG_PORT > mongodb-output-$h-config.log &"
 done
Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-start-routerservers.sh
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-start-routerservers.sh	(revision 31303)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-start-routerservers.sh	(revision 31303)
@@ -0,0 +1,19 @@
+#!/bin/bash
+
+configdb_arg=""
+
+for h in $MONGODB_CONFIG_HOSTS ; do
+  if [ "x$configdb_arg" != "x" ] ; then
+    configdb_arg="$configdb_arg,"
+  fi
+
+  configdb_arg="$configdb_arg$h:$MONGODB_CONFIG_PORT"
+done
+
+
+for h in $MONGODB_ROUTER_HOSTS ; do
+  echo "* Starting MongoDB Router Server on $h:$MONGODB_ROUTER_PORT"
+
+  echo ssh $h "mongos --configdb $configdb_arg --port $MONGODB_ROUTER_PORT > mongodb-output-$h-router.log &"
+
+done
Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-stop-configservers.sh
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-stop-configservers.sh	(revision 31302)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-stop-configservers.sh	(revision 31303)
@@ -3,7 +3,7 @@
 for h in $MONGODB_CONFIG_HOSTS ; do
   echo "*"
-  echo "* Stopping MongoDB Config Server on $h:27019"
+  echo "* Stopping MongoDB Config Server on $h:$MONGODB_CONFIG_PORT"
   echo "*"
-  ssh $h "mongo --host localhost --port 27019 -eval \"db.getSiblingDB('admin').shutdownServer()\""
+  ssh $h "mongo --host localhost --port $MONGODB_CONFIG_PORT -eval \"db.getSiblingDB('admin').shutdownServer()\""
   echo "*****"
   echo ""
Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-stop-routerservers.sh
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-stop-routerservers.sh	(revision 31303)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SCRIPTS/remote-mongodb-stop-routerservers.sh	(revision 31303)
@@ -0,0 +1,13 @@
+#!/bin/bash
+
+for h in $MONGODB_CONFIG_HOSTS ; do
+  echo "*"
+  echo "* Stopping MongoDB Router Server on $h:$MONGODB_ROUTER_PORT"
+  echo "*"
+  ssh $h "mongo --host localhost --port $MONGODB_ROUTER_PORT -eval \"db.getSiblingDB('admin').shutdownServer()\""
+
+#  ssh $h "mongod --dbdir $MONGODB_DBDIR/config-metadata --shutdown"
+
+  echo "*****"
+  echo ""
+done
Index: /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SETUP.bash
===================================================================
--- /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SETUP.bash	(revision 31302)
+++ /other-projects/hathitrust/wcsa/extracted-features-solr/trunk/gslis-cluster/SETUP.bash	(revision 31303)
@@ -53,4 +53,9 @@
 source SETUP/setup-solr.bash
 
+export MONGODB_CONFIG_HOSTS="gc0 gc1 gc2"
+export MONGODB_CONFIG_PORT="27019"
+export MONGODB_ROUTER_HOSTS="gc3 gc4 gc5"
+export MONGODB_ROUTER_PORT="27017"
+export MONGODB_SHARD_HOSTS="gc6 gc7"
 source SETUP/setup-mongodb.bash
 